#!/usr/bin/python
# -*- coding: utf-8 -*-
import gtk,os,string,locale
from mod.grafica import *
from datetime import date
from xml.dom import minidom
from xml.dom.minidom import Document

def Carica_File(self,file_family,ar_categorie,ar_cat_uscita,ar_cat_entrata,model_combo_cat,valuta,root):
	self.notebook = gtk.Notebook()
	self.notebook.set_tab_pos(gtk.POS_TOP)
	self.notebook.set_scrollable(True)
	self.box_nb.pack_start(self.notebook, True, True, 0)

	file_pref = minidom.parse(file_family)
	anno = file_pref.getElementsByTagName('anno')[0].getAttribute("nome")
	file_pref.unlink()        

	self.label_anno = gtk.Label(anno)

	sw_totali = gtk.ScrolledWindow()
	sw_totali.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
	self.notebook.append_page(sw_totali, self.label_anno)

	#creo il modello dei totali
	store_totali = Modello_Store(0)
	tms_totali = gtk.TreeModelSort(store_totali)
	tv_totali = gtk.TreeView(tms_totali)
	tv_totali.set_rules_hint(True)
	tv_totali.set_grid_lines(gtk.TREE_VIEW_GRID_LINES_BOTH)
	#creo le colonne dei totali
	Colonne_Totali(tv_totali)
	Popola_Totali(store_totali,file_family,ar_categorie,ar_cat_uscita,ar_cat_entrata,valuta,root)	

	sw_totali.add_with_viewport(tv_totali)
	 
	Popola_Mese(self,file_family,ar_categorie,ar_cat_uscita,ar_cat_entrata,model_combo_cat,self.notebook,tms_totali,tv_totali,valuta,root)	

	self.notebook.show_all()
	self.set_title("Family Cash 1.0 - "+file_family)


def Modello_Store(tipo):
    #0 modello totali anno
    #1 modello mese

    if tipo==0:
        store = gtk.ListStore(gtk.gdk.Pixbuf, str, str, str, str, str, str, str, str, str, str, str, str, str, str)
    if tipo==1:
        store = gtk.ListStore(gtk.gdk.Pixbuf, str, str, str, gtk.gdk.Pixbuf, str)
    
    return store

def Colonne_Totali(treeView):
	cell_px = gtk.CellRendererPixbuf()
	cell = gtk.CellRendererText()
	cell.set_property("xalign", 1.0)
	cell_cat = gtk.CellRendererText()

	c_img = gtk.TreeViewColumn("", cell_px, pixbuf=0)
	c_img.set_expand(False)
	treeView.append_column(c_img)

	c_cat = gtk.TreeViewColumn("Categoria", cell_cat, text=1)
	c_cat.set_expand(True)
	treeView.append_column(c_cat)

	c_gen = gtk.TreeViewColumn("Gennaio", cell, text=2)
	c_gen.set_expand(True)
	treeView.append_column(c_gen)

	c_feb = gtk.TreeViewColumn("Febbraio", cell, text=3)
	c_feb.set_expand(True)
	treeView.append_column(c_feb)

	c_mar = gtk.TreeViewColumn("Marzo", cell, text=4)
	c_mar.set_expand(True)
	treeView.append_column(c_mar)

	c_apr = gtk.TreeViewColumn("Aprile", cell, text=5)
	c_apr.set_expand(True)
	treeView.append_column(c_apr)

	c_mag = gtk.TreeViewColumn("Maggio", cell, text=6)
	c_mag.set_expand(True)
	treeView.append_column(c_mag)

	c_giu = gtk.TreeViewColumn("Giugno", cell, text=7)
	c_giu.set_expand(True)
	treeView.append_column(c_giu)

	c_lug = gtk.TreeViewColumn("Luglio", cell, text=8)
	c_lug.set_expand(True)
	treeView.append_column(c_lug)

	c_ago = gtk.TreeViewColumn("Agosto", cell, text=9)
	c_ago.set_expand(True)
	treeView.append_column(c_ago)

	c_set = gtk.TreeViewColumn("Settembre", cell, text=10)
	c_set.set_expand(True)
	treeView.append_column(c_set)

	c_ott = gtk.TreeViewColumn("Ottobre", cell, text=11)
	c_ott.set_expand(True)
	treeView.append_column(c_ott)

	c_nov = gtk.TreeViewColumn("Novembre", cell, text=12)
	c_nov.set_expand(True)
	treeView.append_column(c_nov)

	c_dic = gtk.TreeViewColumn("Dicembre", cell, text=13)
	c_dic.set_expand(True)
	treeView.append_column(c_dic)

	c_tot = gtk.TreeViewColumn("Totale", cell, text=14)
	c_tot.set_expand(True)
	treeView.append_column(c_tot)
    
    
def Popola_Totali(store,file_family,ar_categorie,ar_cat_uscita,ar_cat_entrata,valuta,root):
	if file_family!="":
		file_tot = minidom.parse(file_family)
		mesi = file_tot.getElementsByTagName('mesi')[0].childNodes
		img_vuota = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img","ico_vuota.png"))

		ar_tutti_costi=[0,0,0,0,0,0,0,0,0,0,0,0,0]
		for i in xrange (0,len(ar_cat_uscita)):
			cat=ar_cat_uscita[i]
			image = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img",cat[0]))
			ar_cat=[]
			tot_cat=0.0
			mese=0
			for m in range (0,len(mesi)):
				costo_tot=0.0
				if mesi[m].nodeType==3:
					pass
				else:
					op=mesi[m].childNodes
	
					for a in range (0,len(op)):
						if op[a].nodeType==3:
							pass
						else:
							if op[a].getAttribute("categoria")==cat[1]:
								costo_tot=costo_tot+float(op[a].getAttribute("costo"))
		
					tot_cat=tot_cat+costo_tot
					ar_tutti_costi[mese]=ar_tutti_costi[mese]+costo_tot
					mese=mese+1
					costo_tot=Arrotonda(costo_tot,valuta)
					ar_cat.append(costo_tot)
			ar_tutti_costi[12]=ar_tutti_costi[12]+tot_cat
			tot_cat=Arrotonda(tot_cat,valuta)
			store.append([image, cat[1], ar_cat[0], ar_cat[1], ar_cat[2], ar_cat[3], ar_cat[4], ar_cat[5], ar_cat[6], ar_cat[7], ar_cat[8], ar_cat[9], ar_cat[10], ar_cat[11], tot_cat])

		gen=Arrotonda(ar_tutti_costi[0],valuta)
		feb=Arrotonda(ar_tutti_costi[1],valuta)
		mar=Arrotonda(ar_tutti_costi[2],valuta)
		apr=Arrotonda(ar_tutti_costi[3],valuta)
		mag=Arrotonda(ar_tutti_costi[4],valuta)
		giu=Arrotonda(ar_tutti_costi[5],valuta)
		lug=Arrotonda(ar_tutti_costi[6],valuta)
		ago=Arrotonda(ar_tutti_costi[7],valuta)
		sett=Arrotonda(ar_tutti_costi[8],valuta)
		ott=Arrotonda(ar_tutti_costi[9],valuta)
		nov=Arrotonda(ar_tutti_costi[10],valuta)
		dic=Arrotonda(ar_tutti_costi[11],valuta)
		tot=Arrotonda(ar_tutti_costi[12],valuta)
		store.append([img_vuota, "TOTALE SPESE", gen, feb, mar, apr, mag, giu, lug, ago, sett, ott, nov, dic, tot])
		store.append([img_vuota, "", "", "", "", "", "", "", "", "", "", "", "", "", ""])

		ar_tutti_entrate=[0,0,0,0,0,0,0,0,0,0,0,0,0]
		for i in xrange (0,len(ar_cat_entrata)):
			cat=ar_cat_entrata[i]
			image = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img",cat[0]))
			ar_cat=[]
			tot_cat=0.0
			mese=0
			for m in range (0,len(mesi)):
				costo_tot=0.0
				if mesi[m].nodeType==3:
					pass
				else:
					op=mesi[m].childNodes
	
					for a in range (0,len(op)):
						if op[a].nodeType==3:
							pass
						else:
							if op[a].getAttribute("categoria")==cat[1]:
								costo_tot=costo_tot+float(op[a].getAttribute("costo"))
		
					tot_cat=tot_cat+costo_tot
					ar_tutti_entrate[mese]=ar_tutti_entrate[mese]+costo_tot
					mese=mese+1
					costo_tot=Arrotonda(costo_tot,valuta)
					ar_cat.append(costo_tot)
			ar_tutti_entrate[12]=ar_tutti_entrate[12]+tot_cat
			tot_cat=Arrotonda(tot_cat,valuta)
			store.append([image, cat[1], ar_cat[0], ar_cat[1], ar_cat[2], ar_cat[3], ar_cat[4], ar_cat[5], ar_cat[6], ar_cat[7], ar_cat[8], ar_cat[9], ar_cat[10], ar_cat[11], tot_cat])

		gen=Arrotonda(ar_tutti_entrate[0],valuta)
		feb=Arrotonda(ar_tutti_entrate[1],valuta)
		mar=Arrotonda(ar_tutti_entrate[2],valuta)
		apr=Arrotonda(ar_tutti_entrate[3],valuta)
		mag=Arrotonda(ar_tutti_entrate[4],valuta)
		giu=Arrotonda(ar_tutti_entrate[5],valuta)
		lug=Arrotonda(ar_tutti_entrate[6],valuta)
		ago=Arrotonda(ar_tutti_entrate[7],valuta)
		sett=Arrotonda(ar_tutti_entrate[8],valuta)
		ott=Arrotonda(ar_tutti_entrate[9],valuta)
		nov=Arrotonda(ar_tutti_entrate[10],valuta)
		dic=Arrotonda(ar_tutti_entrate[11],valuta)
		tot=Arrotonda(ar_tutti_entrate[12],valuta)
		store.append([img_vuota, "TOTALE ENTRATE", gen, feb, mar, apr, mag, giu, lug, ago, sett, ott, nov, dic, tot])
		store.append([img_vuota, "", "", "", "", "", "", "", "", "", "", "", "", "", ""])

		gen=Arrotonda(ar_tutti_entrate[0]-ar_tutti_costi[0],valuta)
		feb=Arrotonda(ar_tutti_entrate[1]-ar_tutti_costi[1],valuta)
		mar=Arrotonda(ar_tutti_entrate[2]-ar_tutti_costi[2],valuta)
		apr=Arrotonda(ar_tutti_entrate[3]-ar_tutti_costi[3],valuta)
		mag=Arrotonda(ar_tutti_entrate[4]-ar_tutti_costi[4],valuta)
		giu=Arrotonda(ar_tutti_entrate[5]-ar_tutti_costi[5],valuta)
		lug=Arrotonda(ar_tutti_entrate[6]-ar_tutti_costi[6],valuta)
		ago=Arrotonda(ar_tutti_entrate[7]-ar_tutti_costi[7],valuta)
		sett=Arrotonda(ar_tutti_entrate[8]-ar_tutti_costi[8],valuta)
		ott=Arrotonda(ar_tutti_entrate[9]-ar_tutti_costi[9],valuta)
		nov=Arrotonda(ar_tutti_entrate[10]-ar_tutti_costi[10],valuta)
		dic=Arrotonda(ar_tutti_entrate[11]-ar_tutti_costi[11],valuta)
		tot=Arrotonda(ar_tutti_entrate[12]-ar_tutti_costi[12],valuta)
		store.append([img_vuota, "DIFFERENZA", gen, feb, mar, apr, mag, giu, lug, ago, sett, ott, nov, dic, tot])
		store.append([img_vuota, "", "", "", "", "", "", "", "", "", "", "", "", "", ""])

		file_tot.unlink()    
	else:
		img_vuota = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img","ico_vuota.png"))

		for i in xrange (0,len(ar_cat_uscita)):
			cat=ar_cat_uscita[i]
			image = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img",cat[0]))
			store.append([image, cat[1], valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00"])    

		store.append([img_vuota, "TOTALE SPESE", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00"])
		store.append([img_vuota, "", "", "", "", "", "", "", "", "", "", "", "", "", ""])

		for i in xrange (0,len(ar_cat_entrata)):
			cat=ar_cat_entrata[i]
			image = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img",cat[0]))
			store.append([image, cat[1], valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00"])    
		store.append([img_vuota, "TOTALE ENTRATE", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00"])
		store.append([img_vuota, "", "", "", "", "", "", "", "", "", "", "", "", "", ""])

		store.append([img_vuota, "DIFFERENZA", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00", valuta+" 0.00"])
		store.append([img_vuota, "", "", "", "", "", "", "", "", "", "", "", "", "", ""])

    
def Colonne_Mese(treeView,ar_categorie,ar_cat_uscita,ar_cat_entrata,tms_mese,model_combo_cat,notebook,tms_totali,tv_totali,valuta,self,file_family,root):
	cell_px = gtk.CellRendererPixbuf()

	cell_cal = gtk.CellRendererPixbuf()

	cell_combo = gtk.CellRendererCombo()
	cell_combo.set_property("text-column", 0)
	cell_combo.set_property("editable", True)
	cell_combo.set_property("has-entry", False)
	cell_combo.set_property("model", model_combo_cat)
	cell_combo.connect("edited", cellcombo_edited,tms_mese,ar_categorie,notebook,tms_totali,tv_totali,ar_cat_uscita,ar_cat_entrata,valuta,self,file_family,root)

	c_img = gtk.TreeViewColumn("", cell_cal, pixbuf=0)
	c_img.set_expand(False)
	treeView.append_column(c_img)

	cell = gtk.CellRendererText()
	c_data = gtk.TreeViewColumn("Data", cell, text=1)
	c_data.set_expand(False)
	c_data.set_min_width(120)
	c_data.set_max_width(120)
	treeView.append_column(c_data)

	cell = gtk.CellRendererText()
	cell.set_property("editable",True)
	c_desc = gtk.TreeViewColumn("Descrizione", cell, text=2)
	c_desc.set_expand(True)
	cell.connect("edited", celltext_edited,tms_mese,2,notebook,tms_totali,tv_totali,ar_cat_uscita,ar_cat_entrata,valuta,self,file_family)
	treeView.append_column(c_desc)

	cell = gtk.CellRendererText()
	cell.set_property("editable",True)
	cell.set_property('xalign',1.0)
	c_euro = gtk.TreeViewColumn("Costo "+valuta, cell, text=3)
	c_euro.set_expand(False)
	c_euro.set_min_width(150)
	c_euro.set_max_width(150)
	cell.connect("edited", celltext_edited,tms_mese,3,notebook,tms_totali,tv_totali,ar_cat_uscita,ar_cat_entrata,valuta,self,file_family)
	treeView.append_column(c_euro)

	c_img_cat = gtk.TreeViewColumn(" ", cell_px, pixbuf=4)
	c_img_cat.set_expand(False)
	treeView.append_column(c_img_cat)

	c_cat = gtk.TreeViewColumn("Categoria", cell_combo, text=5)
	c_cat.set_expand(False)
	c_cat.set_min_width(250)
	c_cat.set_max_width(250)
	treeView.append_column(c_cat)


def celltext_edited(cell, path, new_text, tms_mese, id_col,notebook,tms_totali,tv_totali,ar_cat_uscita,ar_cat_entrata,valuta,self,file_family):

	mese=notebook.get_current_page()
	treeviewmodel = tms_mese.get_model()
	if id_col==3:
		iter = treeviewmodel.get_iter(path)
		old=treeviewmodel.get_value(iter, id_col)
		num=Controlla_Numero(new_text)
		if num==True:
			cat=treeviewmodel.get_value(iter, 5)
			old=Togli_Valuta(old,valuta)
			new_text=Arrotonda(new_text,valuta)
			aggiorna=1
			pass
		else:
			new_text=old
			aggiorna=0

		treeviewmodel[path][id_col] = (new_text)

		if aggiorna==1:
			Aggiorna_Totali(mese,tms_totali,ar_cat_uscita,ar_cat_entrata,valuta,notebook)
			self.set_title("Family Cash 1.0 - "+file_family+"*")
		else:
			pass

	treeviewmodel[path][id_col] = (new_text)


	
def Aggiorna_Totali(mese,tms_totali,ar_cat_uscita,ar_cat_entrata,valuta,notebook):

    tm_anno=tms_totali.get_model()

    pag=notebook.get_nth_page(mese)

    tm_mese=pag.get_children()[1].get_children()[0].get_children()[0].get_model()

    ar_tot_cat=ar_cat_uscita+ar_cat_entrata

	#uscite
    tot_anno_us=0
    tot_mese=0
    num_cat=0
    for a in xrange(0,len(ar_cat_uscita)):
        cat_temp=ar_cat_uscita[a][1]
        num_row=0
        for row in tm_mese:
            if tm_mese[num_row][5]==cat_temp:
                tot_mese=tot_mese+Togli_Valuta(tm_mese[num_row][3],valuta)
            
            tm_anno[num_cat][mese+1]=Arrotonda(tot_mese,valuta)
            tm_anno[num_cat][14]=Arrotonda((Togli_Valuta(tm_anno[num_cat][2],valuta)+Togli_Valuta(tm_anno[num_cat][3],valuta)+Togli_Valuta(tm_anno[num_cat][4],valuta)+Togli_Valuta(tm_anno[num_cat][5],valuta)+Togli_Valuta(tm_anno[num_cat][6],valuta)+Togli_Valuta(tm_anno[num_cat][7],valuta)+Togli_Valuta(tm_anno[num_cat][8],valuta)+Togli_Valuta(tm_anno[num_cat][9],valuta)+Togli_Valuta(tm_anno[num_cat][10],valuta)+Togli_Valuta(tm_anno[num_cat][11],valuta)+Togli_Valuta(tm_anno[num_cat][12],valuta)+Togli_Valuta(tm_anno[num_cat][13],valuta)),valuta)
            num_row=num_row+1
        tot_anno_us=tot_anno_us+tot_mese
        tm_anno[len(ar_cat_uscita)][mese+1]=Arrotonda(tot_anno_us,valuta)
        tm_anno[len(ar_cat_uscita)][14]=Arrotonda((Togli_Valuta(tm_anno[len(ar_cat_uscita)][2],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)][3],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)][4],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)][5],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)][6],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)][7],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)][8],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)][9],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)][10],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)][11],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)][12],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)][13],valuta)),valuta)

        tot_mese=0
        num_cat=num_cat+1
        
	#entrate
    tot_anno_en=0
    tot_mese=0
    num_cat=0
    for a in xrange(0,len(ar_cat_entrata)):
        cat_temp=ar_cat_entrata[a][1]
        num_row=0
        for row in tm_mese:
            if tm_mese[num_row][5]==cat_temp:
                tot_mese=tot_mese+Togli_Valuta(tm_mese[num_row][3],valuta)
            
            tm_anno[len(ar_cat_uscita)+2+num_cat][mese+1]=Arrotonda(tot_mese,valuta)
            tm_anno[len(ar_cat_uscita)+2+num_cat][14]=Arrotonda((Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+num_cat][2],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+num_cat][3],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+num_cat][4],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+num_cat][5],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+num_cat][6],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+num_cat][7],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+num_cat][8],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+num_cat][9],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+num_cat][10],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+num_cat][11],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+num_cat][12],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+num_cat][13],valuta)),valuta)

            num_row=num_row+1
        tot_anno_en=tot_anno_en+tot_mese
        tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)][mese+1]=Arrotonda(tot_anno_en,valuta)
        tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)][14]=Arrotonda((Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)][2],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)][3],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)][4],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)][5],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)][6],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)][7],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)][8],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)][9],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)][10],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)][11],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)][12],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)][13],valuta)),valuta)

        tot_mese=0
        num_cat=num_cat+1

    tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)+2][mese+1]=Arrotonda((tot_anno_en-tot_anno_us),valuta)
    tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)+2][14]=Arrotonda((Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)+2][2],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)+2][3],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)+2][4],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)+2][5],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)+2][6],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)+2][7],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)+2][8],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)+2][9],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)+2][10],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)+2][11],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)+2][12],valuta)+Togli_Valuta(tm_anno[len(ar_cat_uscita)+2+len(ar_cat_entrata)+2][13],valuta)),valuta)


def Togli_Valuta(num,valuta):
	locale.setlocale(locale.LC_ALL, '')
	num=string.replace(num,valuta,"")
	num=locale.atof(num)
	return num

def Arrotonda(chi,valuta):
	new_text=float(chi)
	locale.setlocale(locale.LC_ALL, '')
	new_text=locale.format("%0.2f", new_text, grouping=True)
	#aggiunta della valuta
	new_text=valuta+" "+new_text
	return new_text

def Controlla_Numero(num):
	for i in xrange(0,len(num)):
		if num[i].isdigit() or num[i]==".":
			control=True
		else:
			control=False
			break
	return control

def cellcombo_edited(cellrenderertext, path, new_text, tms_mese,ar_categorie,notebook,tms_totali,tv_totali,ar_cat_uscita,ar_cat_entrata,valuta,self,file_family,root):
	mese=notebook.get_current_page()
	treeviewmodel = tms_mese.get_model()
	iter = treeviewmodel.get_iter(path)
	treeviewmodel.set_value(iter, 5, new_text)

#	for i in range (0, len(ar_categorie)):
#		if ar_categorie[i][1]==new_text:
#			new_img = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img",ar_categorie[i][0]))
#			treeviewmodel.set_value(iter, 4, new_img)

	img_cat=Recupera_Ico(new_text,ar_categorie,root)
	treeviewmodel.set_value(iter, 4, img_cat)

	cat=new_text
	Aggiorna_Totali(mese,tms_totali,ar_cat_uscita,ar_cat_entrata,valuta,notebook)		
	self.set_title("Family Cash 1.0 - "+file_family+"*")

    
def Scegli_Data(treeview,root):
	path,column=treeview.get_cursor()
	if not column: return
	colname=column.get_title()
	model,iter=treeview.get_selection().get_selected()

	if colname=='':

		dlg=gtk.Dialog("Scegli la data", None, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,(gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT,gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
		dlg.set_size_request(350,250)
		dlg.set_resizable(False)
		dlg.set_deletable(False)
		dlg.set_icon_from_file(os.path.join(root,"img","ico_family.ico"))
		calendario=gtk.Calendar()
		calendario.display_options(gtk.CALENDAR_WEEK_START_MONDAY|gtk.CALENDAR_SHOW_HEADING|gtk.CALENDAR_SHOW_WEEK_NUMBERS|gtk.CALENDAR_SHOW_DAY_NAMES)

		dlg.vbox.pack_start(calendario, False, False, 5)

		dlg.show_all()
		response = dlg.run()
		if response == gtk.RESPONSE_ACCEPT:
			data=calendario.get_date()
			model2 = model.get_model()
			iter = model2.get_iter(path)
			model2.set_value(iter, 1, (str(data[2])+"/"+str(data[1]+1)+"/"+str(data[0])) )
		
		elif response == gtk.RESPONSE_REJECT:
			dlg.destroy()
		dlg.destroy()    

def Popola_Mese(self,file_family,ar_categorie,ar_cat_uscita,ar_cat_entrata,model_combo_cat,notebook,tms_totali,tv_totali,valuta,root):

	img_cal = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img","ico_calendario.png"))

	file_tot = minidom.parse(file_family)
	mesi = file_tot.getElementsByTagName('mesi')[0].childNodes

	for m in range (0,len(mesi)):

		if mesi[m].nodeType==3:
			pass
		else:

			#mese
			label_mese_text=mesi[m].getAttribute("nome")
			label_mese = gtk.Label(label_mese_text)
			#creo il modello del mese
			store_mese = Modello_Store(1)
			tms_mese = gtk.TreeModelSort(store_mese)
			tv_mese = gtk.TreeView(tms_mese)
			tv_mese.set_rules_hint(True)
			tv_mese.set_grid_lines(gtk.TREE_VIEW_GRID_LINES_BOTH)
			tv_mese.connect('cursor-changed', Scegli_Data,root)

			box_bottoni=gtk.HBox()
			b_aggiungi=crea_b_img(gtk.STOCK_ADD,"Aggiungi operazione",200,40,1)
			b_aggiungi.connect("clicked", Aggiungi_Operazione,store_mese,ar_categorie,valuta,self,file_family,root)
			b_togli=crea_b_img(gtk.STOCK_REMOVE,"Cancella operazione",200,40,1)
			b_togli.connect("clicked", Togli_Operazione,tv_mese,tms_mese,store_mese,tms_totali,tv_totali,ar_cat_uscita,ar_cat_entrata,self.notebook,valuta,self,file_family)
			box_bottoni.pack_start(b_aggiungi, False, False, 0)
			box_bottoni.pack_start(b_togli, False, False, 0)

			box_mese=gtk.VBox()
			box_mese.pack_start(box_bottoni, False, False, 5)
			sw_mese = gtk.ScrolledWindow()
			sw_mese.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
			box_mese.pack_start(sw_mese, True, True, 0)
			self.notebook.append_page(box_mese, label_mese)

			Colonne_Mese(tv_mese,ar_categorie,ar_cat_uscita,ar_cat_entrata,tms_mese,model_combo_cat,self.notebook,tms_totali,tv_totali,valuta,self,file_family,root)
			op=mesi[m].childNodes
			for a in range (0,len(op)):

				if op[a].nodeType==3:
					pass
				else:
					data=op[a].getAttribute("data")
					descrizione=op[a].getAttribute("descrizione")
					categoria=op[a].getAttribute("categoria")
					euro=op[a].getAttribute("costo")
					euro=Arrotonda(euro,valuta)
					img_cat=Recupera_Ico(categoria,ar_categorie,root)
					store_mese.append([img_cal,data,descrizione,euro,img_cat,categoria])

			sw_mese.add_with_viewport(tv_mese)

	file_tot.unlink()    

def Recupera_Ico(cat,ar_categorie,root):
	for i in xrange (0,len(ar_categorie)):
		if ar_categorie[i][1]==cat:
			nome=ar_categorie[i][0]
			img = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img",nome))
			return img
			break

def Togli_Operazione(widget,tv_mese,tms_mese,store,tms_totali,tv_totali,ar_cat_uscita,ar_cat_entrata,notebook,valuta,self,file_family):
	try:
		treeselection = tv_mese.get_selection()
		model,iter = treeselection.get_selected()
		path=tms_mese.get_path(iter)
		iter = store.get_iter(path)	
		cat=None
		mese=notebook.get_current_page()
		store.remove(iter)
		Aggiorna_Totali(mese,tms_totali,ar_cat_uscita,ar_cat_entrata,valuta,notebook)
		if "*" in self.get_title():
			pass
		else:
			self.set_title((self.get_title()+"*"))
	except TypeError:
		crea_avviso("Seleziona un'operazione da cancellare")

	
def Aggiungi_Operazione(widget,store,ar_categorie,valuta,self,file_family,root):
	img_cal = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img","ico_calendario.png"))
	data_odierna=date.today()
	data = (str(data_odierna.day)+"/"+str(self.notebook.get_current_page())+"/"+str(data_odierna.year))
	descrizione=""
	euro=valuta+" 0.00"
	categoria=ar_categorie[0][1]
	img_cat = gtk.gdk.pixbuf_new_from_file(os.path.join(root,"img",ar_categorie[0][0]))
	store.append([img_cal,data,descrizione,euro,img_cat,categoria]) 
	if "*" in self.get_title():
		pass
	else:
		self.set_title((self.get_title()+"*"))
    
    
